#include "fpmathf.h"
#include "teleso.h"

#ifndef _3DGfx
#define _3DGfx

typedef struct TGonio
		{
		 FPNum CosA;
		 FPNum SinA;
		 FPNum CosB;
		 FPNum SinB;
		 FPNum CosC;
		 FPNum SinC;
		 FPNum SinAB;
		 FPNum CosAC;
		 FPNum CSAC;
		};

typedef TGonio far* PGonio;

#endif

PGonio CreateGonioTable (void);
extern "C" void far pascal ComputeXRotation (PGonio G,FPNum A);
extern "C" void far pascal ComputeYRotation (PGonio G,FPNum A);
extern "C" void far pascal ComputeZRotation (PGonio G,FPNum A);
extern "C" void far pascal ComputeXYZRotation (PGonio G, FPNum A, FPNum B, FPNum C);
extern "C" void far pascal XRotate3D (PGonio G, PVektor VI, PVektor VO);
extern "C" void far pascal YRotate3D (PGonio G, PVektor VI, PVektor VO);
extern "C" void far pascal ZRotate3D (PGonio G, PVektor VI, PVektor VO);
extern "C" void far pascal XYZRotate3D (PGonio G, PVektor VI, PVektor VO);
extern "C" void far pascal Translate (PVektor V, PVektor TrV);
extern "C" void far pascal AddVectors (PVektor V, PVektor TrV);
extern "C" void far pascal SubstractVectors (PVektor V, PVektor TrV);
extern "C" void far pascal VectorProduct (PVektor A, PVektor B, PVektor V);
extern "C" FPNum far pascal ScalarProduct (PVektor A, PVektor B);
extern "C" void far pascal NormalizeVector (PVektor A, PVektor V);
extern "C" void far pascal NormalVector (PVektor A, PVektor B, PVektor V);
extern "C" void far pascal Normal (void);
